from gint import *
from utime import *
from casioplot import *
screen_h,screen_w,boxsize=DHEIGHT,DWIDTH,23 #set sizes
held,theld,blue2,lcolor,dcolor,bg,tbg,selected,smallcolor,dcolor2,bold,bold2=38034,0,(0,0,255),0xffff,0,59390,54938,4052,38079,(0,0,0),31,(0,0,255)
keys=[KEY_DEL,KEY_1,KEY_2,KEY_3,KEY_4,KEY_5,KEY_6,KEY_7,KEY_8,KEY_9,KEY_UP,KEY_DOWN,KEY_RIGHT,KEY_LEFT,KEY_SHIFT,KEY_EXE,KEY_F6,KEY_F1,KEY_MENU,KEY_EXIT,KEY_F3,KEY_F4]
difficulties2=["easy","medium","hard","extreme"]
games=[[["6  5     ","    491  "," 89     5","8 125   9"," 4 6 3 5 ","5   918 2","7     91 ","  841    ","     5  6"],[
"53  7    ","6  195   "," 98    6 ","8   6   3","4  8 3  1","7   2   6"," 6    28 ","   419  5","    8  79"],[
"3 6  7  8"," 2      4"," 5   17  ","   8 6 3 ","83     59"," 6 7 5   ","  34   7 ","6      4 ","1  6  2 3"]],
[["  7861   ","  8  3   ","56  9  1 ","1   7  85","   345   ","63  1   7"," 5  2  98","   6  5  ","   5371  "],[
"  5   1  "," 7 5 132 "," 6    7  ","   943   ","8  2    9","924 7  1 ","     4  5","54 1 9   ","  6  2 41"],[
"  2   1 6","   56    ","  7    4 ","     1 6 ","1 3  2  7","  6  8 9 ","     94  ","8      3 "," 45 3    "],[
"  6 4 1  ","   1    4"," 5 2 9   ","   5    8","9 4 8   3","    6    "," 6  32   ","         "," 976     "],[
"   57  8 ","3     1  ","  6  8   ","6   4    ","7 8 61   "," 1 8   5 ","5        ","     73 1","2  9 3   "],[
"        7"," 1  94   ","2  7  8  ","    6   8","    1  2 "," 974    5","    59   ","82    34 ","  6   2  "],[
"27   9  8"," 8      2"," 6     9 ","      72 ","3 149    ","    1   4","     83  ","  4      ","    4 8 5"]],
[["  63 7   ","  4     5","1    6 82","2 5 3 1 6","   2  3  ","9   7   4"," 5       "," 1       ","  81 9 4 "],[
" 8 7    5","5    9   "," 2935 6 8","     32 6"," 4    8  ","    684  "," 3     7 "," 5    9 4","  1  4   "],[
" 95  2  4","      58 ","     16  ","  1   4 9","5   7    ","   8     "," 72      ","  671 9  ","4  6     "]],
[[" 5 39    ","   2  3 9","1    6  8","   8     ","3  57   4"," 47      ","    1  4 "," 3    1  ","5 6 3 2  "],[
"9  3  8  "," 4 8     ","       9 ","        5","  1 2 37 "," 53 4  2 ","8  93 4  ","19  72   "," 6       "],[
"        8","  7 5 9 3"," 36  8   ","        5"," 2       "," 841  67 ","  9 1    ","     632 "," 7  83 14"]]]
nums=[[],["  ## "," ### ","   # ","   # ","   # "," ####"],[
" ### ","#   #","   # ","  #  "," #   ","#####"],[
" ### ","#   #","  ## ","    #","#   #"," ### "],[
"  ## "," # # ","#  # ","#####","   # ","   # "],[
"#####","#    ","#### ","    #","#   #"," ### "],[
" ####","#    ","#### ","#   #","#   #"," ### "],[
"#####","    #","   # ","  #  ","  #  ","  #  "],[
" ### ","#   #"," ### ","#   #","#   #"," ### "],[
" ### ","#   #","#   #"," ####","    #","#### "]]
b,difficulties=boxsize,[a+" games" for a in difficulties2]
startx,starty=int(screen_w/2-4.5*b),int(screen_h/2-4.5*b)
def rgb(x="black"):return{"black":dcolor2,"blue":blue2,"bold":bold2}[x]
def hexed(x="black"):return{"black":dcolor,"light":smallcolor,"bold":bold}[x]
def getkey(passkeys=list(range(len(keys))),stops=[18,19],rep=1):
  global key,go
  if rep:rep=GETKEY_REP_ARROWS
  try:
    sleep(.04)
    while 1:
      try:
        a=getkey_opt(GETKEY_MENU+rep,None)
        key=keys.index(a.key)
        if key in passkeys+[18,19]:break
      except ValueError:pass
    cleareventflips()
    clearevents()
  except KeyboardInterrupt:pass
  if key in stops:go=False
def box(c,d,l,h,t=1,border=1,fill=1,e=10,box=0,long=False):
  border,fill,box=dcolor if border==1 else border,lcolor if fill==1 else fill,classic if box==0 else box
  if not box:
    c,d,l,h=c+e-2,d+e-2,l-2*e+4,h-2*e+5+10*long
    if long:d,e=d-2,8
    for i in (c+2,d+2,e,border,border),(c+2+t,d+2+t,e,fill,fill),(c+l-2,d+h-2,e,border,border),(c+l-2-t,d+h-2-t,e,fill,fill),(c+l-2,d+2,e,border,border),(c+l-2-t,d+2+t,e,fill,fill),(c+2,d+h-2,e,border,border),(c+2+t,d+h-2-t,e,fill,fill):dcircle(*i)
    for i in (c+4,d+3-e,c+l-4,d+h+e-3,fill),(c+3-e,d+4,c+l+e-3,d+h-4,fill):drect(*i)
    if t>0:
      for i in (c+4,d+2-e,c+l-4,d+1-e+t,border),(c+4,d+h+e-2,c+l-4,d+h+e-1-t,border),(c+2-e,d+4,c+1-e+t,d+h-3,border),(c+l+e-2,d+4,c+l+e-1-t,d+h-3,border):drect(*i)
  else:
    drect(c,d,c+l,d+h,border)
    drect(c+t,d+t,c+l-t,d+h-t,fill)
def textbox(c,d,l,h,s="",tx=0,ty=5,t=2,border=1,fill=1,tc=1,v1=True,f="",m=1,long=False):
  tc,border,fill=dcolor if tc==1 else tc,dcolor if border==1 else border,tbg if fill==1 else fill
  if l==0:l=int(14+8.6*len(s))
  if l<60 and m==1:l=60
  if tx==0:tx=int(l/2-4.3*len(s))
  if c>screen_w-l+2:c,l=screen_w-l-1,l+2
  box(c,d,l,h,t,border,fill,long=long)
  if v1:dtext(c+t+tx,d+t+ty,tc,s)
  else:draw_string(c+t+tx,d+t+ty,s,rgb(),f)
def gx(x):return startx+b*x+x//3
def gy(y):return starty+b*y+y//3
def drawbox(x,y,c=1,f=1):box(gx(x),gy(y),b,b,border=dcolor if c==1 else c,fill=lcolor if f==1 else f,box=True)
def fx(f,w=0,t=93,p=0):return{"f1":(-2,screen_h-22+p,w,24),"f6":(screen_w-w+3,screen_h-22+p,w,24),"f3":(int(screen_w//2-t),screen_h-22+p,w,24),"f4":(int(screen_w//2+1),screen_h-22+p,w,24),"topright":(screen_w-w+2,0-2*(classic),w,17+8*(classic))}[f]
buttons={"f1":"","f3":"","f4":"","f6":""}
def button(f,text,e=False,pressed=0):
  global buttons
  buttons[f]=text
  box(*fx(f,93),t=1,fill=bg,border=bg,long=True)
  if not e:textbox(*fx(f,t=15+8.6*len(text),p=pressed),s=text,fill=held if pressed else tbg,tc=theld if pressed else dcolor,long=True)
def num(n,x,y,c):
  for a in range(6):
    for b in range(5):
      if nums[n][a][b]=="#":dpixel(x+b,y+a,c)
def drawnum(n,x,y,c,s):
  if s==1:
    for a in ntest[y][x]:num(a,gx(x)+2+(a-1)%3*7,gy(y)+2+(a-1)//3*7,hexed(c))
  else:draw_string(gx(x)+7+2*(int(n)==1),gy(y)+3,str(n),rgb(c))
def updrawnum(x,y,bold=False):
  s=test[y][x]
  n=play[y][x]+s
  if n!=0:
    if bold and fade:
      f,c,i=11,rgb("bold"),ntest[y][x][-1] if s==1 else 0
      for a in range(f+1):
        if s==0:draw_string(gx(x)+7+2*(int(n)==1),gy(y)+3,str(n),(int(a/f*c[0]),int(251-a/f*(251-c[1])),int(165-a/f*(165-c[2]))))
        else:num(i,gx(x)+2+(i-1)%3*7,gy(y)+2+(i-1)//3*7,C_RGB(int((a/f*c[0])/8.23),int((251-a/f*(251-c[1]))/8.23),int((165-a/f*(165-c[2]))/8.23)))
        dupdate()
    else:drawnum(n,x,y,"black" if data[y][x] != " " else "bold" if bold else "blue" if s==0 else "light",s)
def update():
  if not fade:drawbox(oldx,oldy)
  if not fade or len(ntest[y][x])<2:drawbox(x,y,f=selected)
  if not fade:updrawnum(oldx,oldy)
  updrawnum(x,y,True)
  dupdate()
def drawboard(part=[(0,9),(0,9)]):
  color="black" if win else "blue"
  for d in range(*part[1]):
    for c in range(*part[0]):
      drawbox(c,d)
      if data[d][c] != " ":drawnum(data[d][c],c,d,"black",0)
      elif play[d][c] > 0:drawnum(play[d][c],c,d,color,0)
      else:drawnum(0,c,d,"light",1)
  if win:
    textbox(9,100,69,25,"you win!",5)
    button("f6","new game")
    button("f1","",True)
    dupdate()
  else:
    button("f1","back")
    button("f6","reset")
    update()
def start():
  global play,test,ntest,small,win,new
  win,new,small=False,True,False
  play,test=[[0 if  a==" " else int(a) for a in row]for row in data],[[0 for a in row]for row in data]
  ntest=[[[] for a in row]for row in data]
  dclear(bg)
  box(gx(0)-1,gy(0)-1,9*b+4,9*b+4,box=True)
  button("topright",difficulties2[diff])
  drawboard()
def option(a,c=1,c2=1,add2=0,s=0):
  c,c2,x,y=dcolor if c==1 else c,lcolor if c2==1 else c2,a//5*31,a%5*32
  if add==1:x,y=y,x
  w2,y,x=w-70*r,y+50+30*(pos==5),x+200-85*(pos==5)+(w+12)*r
  box(x,y,w2+add,26,fill=bg,t=0)
  box(x+2,y+2,w2-1,24)
  textbox(x,y,w2+s+add2,25+s,options[a],i,border=c,fill=c2,m=0)
def livemenu(settings=False):
  global r,a,w,options,i,add
  dclear(bg)
  button("f6","select" if pos!=5 else "on/off")
  if pos!=5:
    textbox(34,44,144,59,"Sudoku",12,9,v1=False,f="large")
    textbox(40,110,0,23,"by Potchkee")
  r,passkeys,options,stops=0,list(range(14,20)),difficulties,[18]
  if pos==1:
    a,w,i,add=diff,125,5,5
    stops.append(19)
    passkeys.extend([20,21])
    for n in ("f1","about"),("f3","controls"),("f4","settings"):button(*n)
  elif pos==2:
    textbox(187,-2-10*(not classic),126,25+10*(not classic),options[diff],ty=5+10*(not classic))
    a,w,i,add,options=gamenum,26,5,1,[str(a+1) for a in range(len(games[diff]))]
  else:
    w,options=108,("dark mode","legacy mode")
    for o in range(2):option(o,c2=tbg)
    r,a,i,add,options=1,spos,5,5,("off" if light else "on","on" if classic else "off")
    textbox(142,-2-10*(not classic),115,25+10*(not classic),"settings",ty=5+10*(not classic))
  if pos!=1:button("f1","back")
  n=len(options)
  for o in range(n):option(o)
  while go and n>0:
    for f in range(add):
      option(a,c2=selected,add2=f,s=1)
      dupdate()
    getkey([10,11,12,13]+list(passkeys),stops,pos==2)
    olda=a
    if key==10 and a>=5/add:a-=5//add
    if key==11:
      if a<n-5//add:a+=5//add
      elif add==1 and a<n-n%5:a=n-1
    if key==13 and a>0:a-=1
    if key==12 and a<n-1:a+=1
    if olda!=a:option(olda)
    if settings and key in (17,19):a="exit"
    if key in (passkeys):break
  holding()
  return a
def textscreen(*text):
  global pos
  dclear(bg)
  button("f1","back")
  for t in text:textbox(*t)
  if pos==3:dtext(48,160,dcolor,"or planet-casio.com")
  dupdate()
  getkey([17],[18])
  holding()
  pos=1
def holding():
  if go:
    f="f"+str(keycode_function(keys[key]))
    if key in (14,15):f="f6"
    if key == 19:f="f1"
    text=buttons[f]
    for n in range(3):
      button(f,text,pressed=n)
      dupdate()
    while 1:
      clearevents()
      if keyreleased(keys[key]):break
def areyousure(quit=0,stops=[18,19]):
  text,l="are you sure",64
  if quit:text,l=text+" you want to quit",129
  textbox(screen_w//2-l,screen_h//2-18,2*l,36,text+"?",10,10)
  for i in("f1","cancel"),("f6","yes"):button(*i)
  dupdate()
  getkey([16,17],stops)
  holding()
def check(a):
  global cont
  if [a.count(c) for c in range(1,10)].count(0)!=0:cont=False
classic,fade,light,new,go,diff,pos=False,False,True,True,True,0,1
while go:
  if new:
    while go:
      if pos==1:
        spos,diff,gamenum=0,livemenu(),0
        pos=3 if key==17 else 4 if key==20 else 5 if key==21 else 2
      if go and pos==2:
        gamenum,pos=livemenu(),1
        if key not in (17,19):break
      if go and pos==3:textscreen([34,44,144,59,"Sudoku",12,9,2,dcolor,tbg,hexed(),False,"large"],[40,110,0,23,"by Potchkee"],[155,110,0,23,"version 1.2"],[40,140,0,38,"download at cemetech.net"])
      if go and pos==4:textscreen([43,90,0,23,"use the number pad to enter numbers"],[27,120,0,23,"press shift/exe to enter candidate mode"])
      if go and pos==5:
        spos=livemenu(True)
        if spos==0:
          light=not light
          if light:held,theld,lcolor,dcolor,bg,tbg,dcolor2,blue2,smallcolor,bold,bold2=38034,0,0xffff,0,59390,54938,(0,0,0),(0,0,255),38079,31,(0,0,255)
          else:held,theld,lcolor,dcolor,bg,tbg,dcolor2,blue2,smallcolor,bold,bold2=42676,0xffff,0x0926,0xffff,0x1a08,0x5c0e,(255,255,255),(76,230,176),0x8df5,0x5c0e,(90,130,115)
        if spos==1:classic=not classic
        if spos=="exit":pos=1
    pos,data,x,y,oldx,oldy=1,games[diff][gamenum],0,0,0,0
  if go:start()
  while go:
    getkey()
    oldx,oldy,a,fade=x,y,key,False
    if a==10 and y>0:y-=1
    if a==11 and y<8:y+=1
    if a==12 and x<8:x+=1
    if a==13 and x>0:x-=1
    if a<10 and data[y][x]==" ":
      if small and a>0:
        if ntest[y][x].count(a)==0:
          fade,play[y][x],test[y][x]=True,0,1
          ntest[y][x].append(a)
      else:
        if a>0 and play[y][x]!=a:fade=True
        play[y][x],test[y][x],ntest[y][x],cont=a,0,[],True
        for c in range(9):
          if play[c].count(0)!=0:cont=False
        if cont:
          for n in range(2):
            for d in range(9):
              check(play[d])
            play=[list(c) for c in zip(*play)]
        if cont:
          for c in range(3):
            for d in range(3):
              e,f=3*c,3*d
              check(play[e][f:f+3]+play[e+1][f:f+3]+play[e+2][f:f+3])
        win=cont
    if a in (14,15):
      small=not small
      if small:draw_string(5,5,"*",rgb())
      else:drect(5,5,30,30,bg)
    update()
    if a in (16,17):
      holding()
      if play==[[0 if  a==" " else int(a) for a in row]for row in data] and test==[[0 for a in row]for row in data]:moved=False
      else: moved=True
      if moved==True:areyousure(stops=[18])
      if key==16 or not moved:
        if a==16:new=False
        else:pos=2
        break
      if go:drawboard(part=[(1,8),(3,6)])
    if not(go):
      areyousure(1)
      if key in (17,19):
        go=True
        box(gx(-2),gy(3),b*13,b*3,0,fill=bg)
        box(gx(0)-1,gy(3),b*9+4,b*3)
        drawboard(part=[(0,9),(3,6)])
    if win:
      drawboard()
      getkey([16])
      break
#a,w,i,add,options=spos,140,5,5,("dark mode: "+("off" if light else "on"),"legacy mode: "+("on" if classic else "off"))
print("\n"*7+" "*20+"thanks for playing"+"\n"*6)